/* GPIO Example

   This example code is in the Public Domain (or CC0 licensed, at your option.)

   Unless required by applicable law or agreed to in writing, this
   software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
   CONDITIONS OF ANY KIND, either express or implied.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "driver/gpio.h"
#include "motors.h"
#include "encoders.h"
#include "hwTimer.h"
#include "control.h"

#define OMNI_CTRL_TIMER 0.05 // s
#define MAX_OUTPUT 100.0
#define NMOTORS 3
#define OMNI_NRO_TIMER 0

void app_main(void)
{
    printf("Configuring Initial Parameters of mcpwm...\n");
    omni_init();
    omni_set_enable(true);
    int vel;
    while (1) {       
        for (size_t i = 100; 98 < i; i--)
        {
            vel = i;
            printf("---------------------------------------------------------------------\n");
            printf("Busco vel=%d\n",vel);
            printf("---------------------------------------------------------------------\n");
            omni_drive(vel,0,0,0);
            vTaskDelay( 1000/ portTICK_RATE_MS);
        }
        omni_drive(0,0,0,0);
        vTaskDelay(1000/ portTICK_RATE_MS);
        for (size_t i = 100; 98 < i; i--)
        {
            vel = i;
            printf("---------------------------------------------------------------------\n");
            printf("Busco vel=%d\n",vel);
            printf("---------------------------------------------------------------------\n");
            omni_drive(0,vel,0,0);
            vTaskDelay( 1000/ portTICK_RATE_MS);
        }
        for (size_t i = 100; 98 < i; i--)
        {
            vel = i;
            printf("---------------------------------------------------------------------\n");
            printf("Busco vel=%d\n",vel);
            printf("---------------------------------------------------------------------\n");
            omni_drive(-vel,0,0,0);
            vTaskDelay( 1000/ portTICK_RATE_MS);
        }
        omni_drive(0,0,0,0);
        vTaskDelay(1000/ portTICK_RATE_MS);
        for (size_t i = 100; 98 < i; i--)
        {
            vel = i;
            printf("---------------------------------------------------------------------\n");
            printf("Busco vel=%d\n",vel);
            printf("---------------------------------------------------------------------\n");
            omni_drive(0,-vel,0,0);
            vTaskDelay( 1000/ portTICK_RATE_MS);
        }
    } 
}